Subject: Re: bug#39823: 26.3; update-directory-autoloads regression from Emacs 26 to Emacs 27

From: Eli Zaretskii <[email-masked]>
Date: Wed, 08 Apr 2020 22:09:13 +0300

> From: Maxim Cournoyer <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Wed, 08 Apr 2020 12:41:26 -0400
> 
> >> I think it could be nice to update update-directory-autoloads to work in
> >> a lexical setting before closing this bug, though.
> >
> > Update how?
> 
> Update `update-directory-autoloads' so that it accepts a &key style arg
> for the ‘generated-autoload-file’ file name.  Currently it must be
> dynamically bound prior to calling `update-directory-autoloads'.

I don't think this is related to this bug report.  It's a separate
issue: you want to enhance the API of update-directory-autoloads.

> > This discussion mentioned a way to turn off lexical-binding in --eval
> > command-line arguments (which is also in NEWS), so why do we need to
> > do anything else specifically for update-directory-autoloads?
> 
> Because I suspect that 'update-directory-autoloads' is probably used
> most of the time with the command line --eval (in Makefiles and build
> scripts), and that the wrap in eval workaround, while it works, is
> rather obscure.

The Emacs build also uses it, it just uses "-l autoload" before --eval.
It sounds like the right solution to me, something that people should
use if they need to call this function from a Makefile.